<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="护理业务数据id" prop="applyId">
        <el-input
          v-model="queryParams.applyId"
          placeholder="请输入护理业务数据id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="评分人id" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入评分人id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="评价" prop="assess">
        <el-input
          v-model="queryParams.assess"
          placeholder="请输入评价"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['care:scores:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['care:scores:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['care:scores:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['care:scores:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="scoresList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="业务评分表的唯一标识符" align="center" prop="scoreId" />
      <el-table-column label="护理业务数据id" align="center" prop="applyId" />
      <el-table-column label="评分人id" align="center" prop="userId" />
      <el-table-column label="评价" align="center" prop="assess" />
      <el-table-column label="得此评价原因" align="center" prop="reason" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['care:scores:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['care:scores:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改业务评分对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="scoresRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="护理业务数据id" prop="applyId">
          <el-input v-model="form.applyId" placeholder="请输入护理业务数据id" />
        </el-form-item>
        <el-form-item label="评分人id" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入评分人id" />
        </el-form-item>
        <el-form-item label="评价" prop="assess">
          <el-input v-model="form.assess" placeholder="请输入评价" />
        </el-form-item>
        <el-form-item label="得此评价原因" prop="reason">
          <el-input v-model="form.reason" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="删除标志" prop="delFlag">
          <el-input v-model="form.delFlag" placeholder="请输入删除标志" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Scores">
import { listScores, getScores, delScores, addScores, updateScores } from "@/api/care/scores";

const { proxy } = getCurrentInstance();

const scoresList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    applyId: null,
    userId: null,
    assess: null,
    reason: null,
  },
  rules: {
    applyId: [
      { required: true, message: "护理业务数据id不能为空", trigger: "blur" }
    ],
    userId: [
      { required: true, message: "评分人id不能为空", trigger: "blur" }
    ],
    assess: [
      { required: true, message: "评价不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询业务评分列表 */
function getList() {
  loading.value = true;
  listScores(queryParams.value).then(response => {
    scoresList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    scoreId: null,
    applyId: null,
    userId: null,
    assess: null,
    reason: null,
    delFlag: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("scoresRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.scoreId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加业务评分";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _scoreId = row.scoreId || ids.value
  getScores(_scoreId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改业务评分";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["scoresRef"].validate(valid => {
    if (valid) {
      if (form.value.scoreId != null) {
        updateScores(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addScores(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _scoreIds = row.scoreId || ids.value;
  proxy.$modal.confirm('是否确认删除业务评分编号为"' + _scoreIds + '"的数据项？').then(function() {
    return delScores(_scoreIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('care/scores/export', {
    ...queryParams.value
  }, `scores_${new Date().getTime()}.xlsx`)
}

getList();
</script>
